> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://reference.flatfile.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://reference.flatfile.com/_mcp/server.

# Get a mapping rule

GET https://api.x.flatfile.com/v1/mapping/{programId}/rules/{mappingId}

Get a mapping rule from a program

Reference: https://reference.flatfile.com/api-reference/mapping/get-rule

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `programId` (string, required) — ID of the program
- `mappingId` (string, required) — ID of mapping rule

## Response

### 200

- `data` (MappingRule, required)

## Errors

### 400 Bad Request Error

- `errors` (list of Error, required)

### 404 Not Found Error

- `errors` (list of Error, required)

## Types

### MappingRule

- `createdAt` (datetime, required) — Time the mapping rule was created
- `id` (string, required) — ID of the mapping rule
- `name` (string, required) — Name of the mapping rule
- `type` (string, required)
- `updatedAt` (datetime, required) — Time the mapping rule was last updated
- `acceptedAt` (datetime, optional) — Time the mapping rule was last updated
- `acceptedBy` (string, optional) — User ID of the contributor of the mapping rule
- `confidence` (integer, optional) — Confidence of the mapping rule
- `config` (any, optional)
- `createdBy` (string, optional) — User ID of the user who suggested the mapping rule
- `deletedAt` (datetime, optional) — Time the mapping rule was deleted
- `metadata` (any, optional) — Metadata of the mapping rule

### Error

- `message` (string, required)
- `key` (string, optional)

## Examples

**Response**

```json
{
  "data": {
    "createdAt": "2021-01-01T00:00:00Z",
    "id": "mapping-rule-id",
    "name": "Assign mapping rule",
    "type": "assign",
    "updatedAt": "2021-01-01T00:00:00Z",
    "confidence": 1,
    "config": {},
    "createdBy": "us_usr_YOUR_ID",
    "metadata": {}
  }
}
```

**SDK Code**

```python Example0
import requests

url = "https://api.x.flatfile.com/v1/mapping/us_mp_YOUR_ID/rules/us_mr_YOUR_ID"

headers = {
    "X-Disable-Hooks": "true",
    "Authorization": "Bearer <token>"
}

response = requests.get(url, headers=headers)

print(response.json())
```

```typescript Example0
import { FlatfileClient } from "@flatfile/api";

const client = new FlatfileClient({ token: "YOUR_TOKEN" });
await client.mapping.getRule("us_mp_YOUR_ID", "us_mr_YOUR_ID");

```

```go Example0
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.x.flatfile.com/v1/mapping/us_mp_YOUR_ID/rules/us_mr_YOUR_ID"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("X-Disable-Hooks", "true")
	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example0
require 'uri'
require 'net/http'

url = URI("https://api.x.flatfile.com/v1/mapping/us_mp_YOUR_ID/rules/us_mr_YOUR_ID")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["X-Disable-Hooks"] = 'true'
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Example0
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.x.flatfile.com/v1/mapping/us_mp_YOUR_ID/rules/us_mr_YOUR_ID")
  .header("X-Disable-Hooks", "true")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Example0
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.x.flatfile.com/v1/mapping/us_mp_YOUR_ID/rules/us_mr_YOUR_ID', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'X-Disable-Hooks' => 'true',
  ],
]);

echo $response->getBody();
```

```csharp Example0
using RestSharp;

var client = new RestClient("https://api.x.flatfile.com/v1/mapping/us_mp_YOUR_ID/rules/us_mr_YOUR_ID");
var request = new RestRequest(Method.GET);
request.AddHeader("X-Disable-Hooks", "true");
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Example0
import Foundation

let headers = [
  "X-Disable-Hooks": "true",
  "Authorization": "Bearer <token>"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/mapping/us_mp_YOUR_ID/rules/us_mr_YOUR_ID")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```